package net.cattaka.rdbassistant.bean;

import java.net.URL;
import java.util.HashMap;

import javax.swing.ImageIcon;

import net.cattaka.jspf.JspfBundle;
import net.cattaka.rdbassistant.RdbaMessageConstants;
import net.cattaka.rdbassistant.jspf.core.RdbaJspfBundle;
import net.cattaka.rdbassistant.script.core.RdbaScript;
import net.cattaka.swing.TextFileChooser;

public class RdbaSingletonBundle {
	private HashMap<String,Object> resourceMap = new HashMap<String, Object>();
	private TextFileChooser sqlTextFileChooser;
	private TextFileChooser scriptTextFileChooser;
	private RdbaJspfBundle jspfDefaultBundle;
	private JspfBundle<RdbaScript> scriptBundle;
	
	public RdbaSingletonBundle() {
		createResource();
	}
	
	// -- getter/setter -------------------------------------------------
	public RdbaJspfBundle getDefaultJspfBundle() {
		return jspfDefaultBundle;
	}

	public void setDefaultJspfBundle(RdbaJspfBundle jspfBundle) {
		this.jspfDefaultBundle = jspfBundle;
	}
	
	public JspfBundle<RdbaScript> getScriptBundle() {
		return scriptBundle;
	}

	public void setScriptBundle(JspfBundle<RdbaScript> scriptBundle) {
		this.scriptBundle = scriptBundle;
	}

	public TextFileChooser getSqlTextFileChooser() {
		return sqlTextFileChooser;
	}

	public void setSqlTextFileChooser(TextFileChooser sqlTextFileChooser) {
		this.sqlTextFileChooser = sqlTextFileChooser;
	}

	public TextFileChooser getScriptTextFileChooser() {
		return scriptTextFileChooser;
	}

	public void setScriptTextFileChooser(TextFileChooser scriptTextFileChooser) {
		this.scriptTextFileChooser = scriptTextFileChooser;
	}

	public Object getResource(String name) {
		return resourceMap.get(name);
	}

	// -- other -------------------------------------------------
	// リソースの作成
	private void createResource() {
		// アイコン
		{
			URL iconNewUrl = this.getClass().getClassLoader().getResource("icon/m_new.png");
			URL iconOpenUrl = this.getClass().getClassLoader().getResource("icon/m_open.png");
			URL iconSaveUrl = this.getClass().getClassLoader().getResource("icon/m_save.png");
			URL iconSaveasUrl = this.getClass().getClassLoader().getResource("icon/m_saveas.png");
			URL iconRunUrl = this.getClass().getClassLoader().getResource("icon/m_run.png");
			URL iconCompileUrl = this.getClass().getClassLoader().getResource("icon/m_compile.png");
			URL iconFindUrl = this.getClass().getClassLoader().getResource("icon/m_find.png");
			URL iconGcUrl = this.getClass().getClassLoader().getResource("icon/m_gc.png");
			URL iconTransposeUrl = this.getClass().getClassLoader().getResource("icon/m_transpose.png");
			ImageIcon iconNew = new ImageIcon(iconNewUrl);
			ImageIcon iconOpen = new ImageIcon(iconOpenUrl);
			ImageIcon iconSave = new ImageIcon(iconSaveUrl);
			ImageIcon iconSaveas = new ImageIcon(iconSaveasUrl);
			ImageIcon iconRun = new ImageIcon(iconRunUrl);
			ImageIcon iconCompile = new ImageIcon(iconCompileUrl);
			ImageIcon iconFind = new ImageIcon(iconFindUrl);
			ImageIcon iconGc = new ImageIcon(iconGcUrl);
			ImageIcon iconTranspose = new ImageIcon(iconTransposeUrl);
			
			resourceMap.put(RdbaMessageConstants.ICON_NEW, iconNew);
			resourceMap.put(RdbaMessageConstants.ICON_OPEN, iconOpen);
			resourceMap.put(RdbaMessageConstants.ICON_SAVE, iconSave);
			resourceMap.put(RdbaMessageConstants.ICON_SAVEAS, iconSaveas);
			resourceMap.put(RdbaMessageConstants.ICON_RUN, iconRun);
			resourceMap.put(RdbaMessageConstants.ICON_COMPILE, iconCompile);
			resourceMap.put(RdbaMessageConstants.ICON_FIND, iconFind);
			resourceMap.put(RdbaMessageConstants.ICON_GC, iconGc);
			resourceMap.put(RdbaMessageConstants.ICON_TRANSPOSE, iconTranspose);
		}
	}
}
