package net.cattaka.rdbassistant.gui.table;

import java.sql.PreparedStatement;
import java.sql.SQLException;

public class StatementExecuteThread extends Thread {
	private PreparedStatement statement;
	private boolean executeResult;
	private SQLException sqlException;
	private boolean canceled;
	
	public StatementExecuteThread(PreparedStatement statement) {
		super();
		this.statement = statement;
		this.canceled = false;
	}
	@Override
	public void run() {
		try {
			this.executeResult = statement.execute();
		} catch(SQLException e) {
			sqlException = e;
		}
	}

	public void cancel() {
		this.canceled = true;
		try {
			this.statement.cancel();
		} catch(SQLException e) {
			if (sqlException != null) {
				sqlException = e;
			}
		}
	}
	
	public boolean getExecuteResult() {
		return executeResult;
	}
	
	public SQLException getSqlException() {
		return sqlException;
	}

	public boolean isCanceled() {
		return canceled;
	}
}
